﻿Imports System.Threading.Tasks
Imports System.Windows.Forms

Namespace SolSoft.ObjectOrientedGuiStartup.WindowsForms
	''' <summary>
	''' Third refactoring: extract the hosting boilerplate from the class
	''' </summary>
	Friend Class Program3
		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread>
		Shared Sub Main()
			Application.EnableVisualStyles()
			Application.SetCompatibleTextRenderingDefault(False)

			Dim p As New Program3()
			AddHandler p.ExitRequested, AddressOf p_ExitRequested

			p.Start()

			Application.Run()
		End Sub

		Private Shared Sub p_ExitRequested(ByVal sender As Object, ByVal e As EventArgs)
			Application.ExitThread()
		End Sub

		Private ReadOnly m_mainForm As Form1
		Private Sub New()
			m_mainForm = New Form1()
			AddHandler m_mainForm.FormClosed, AddressOf m_mainForm_FormClosed
		End Sub

		Public Sub Start()
			m_mainForm.Initialize()
			m_mainForm.Show()
		End Sub

		Public Event ExitRequested As EventHandler(Of EventArgs)
		Private Sub m_mainForm_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs)
			OnExitRequested(EventArgs.Empty)
		End Sub

		Protected Overridable Sub OnExitRequested(ByVal e As EventArgs)
			RaiseEvent ExitRequested(Me, e)
		End Sub
	End Class
End Namespace
