﻿Imports System.Text
Imports System.Threading.Tasks

Namespace SolSoft.ObjectOrientedGuiStartup.Wpf
	''' <summary>
	''' Second refactoring: separate message loop
	''' </summary>
	Friend Class Program2
		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread>
		Shared Sub Main()
			Dim p As New Program2()
			p.Start()
		End Sub

		Private ReadOnly m_app As AppNoStartupUri
		Private Sub New()
			m_app = New AppNoStartupUri With {.ShutdownMode = ShutdownMode.OnExplicitShutdown}
			m_app.InitializeComponent()
		End Sub

		Public Sub Start()
			Dim viewModel As New MainViewModel()
			AddHandler viewModel.CloseRequested, AddressOf viewModel_CloseRequested
			viewModel.Initialize()

			Dim mainForm As New MainWindow()
			AddHandler mainForm.Closed, Sub(sender, e) viewModel.RequestClose()

			mainForm.DataContext = viewModel
			mainForm.Show()
			m_app.Run()
		End Sub

		Private Sub viewModel_CloseRequested(ByVal sender As Object, ByVal e As EventArgs)
			m_app.Shutdown()
		End Sub
	End Class
End Namespace
