﻿Imports System.Text
Imports System.Threading.Tasks

Namespace SolSoft.ObjectOrientedGuiStartup.Wpf
	''' <summary>
	''' Third refactoring: extract the hosting boilerplate from the class
	''' </summary>
	Friend Class Program3
		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread>
		Shared Sub Main()
			Dim app As AppNoStartupUri = New AppNoStartupUri With {.ShutdownMode = ShutdownMode.OnExplicitShutdown}
			app.InitializeComponent()

			Dim p As New Program3()
			AddHandler p.ExitRequested, Sub(sender, e) app.Shutdown()
			p.Start()

			app.Run()
		End Sub

		Private Sub New()

		End Sub

		Public Sub Start()
			Dim viewModel As New MainViewModel()
			AddHandler viewModel.CloseRequested, AddressOf viewModel_CloseRequested
			viewModel.Initialize()

			Dim mainForm As New MainWindow()
			AddHandler mainForm.Closed, Sub(sender, e) viewModel.RequestClose()

			mainForm.DataContext = viewModel
			mainForm.Show()
		End Sub

		Public Event ExitRequested As EventHandler(Of EventArgs)
		Private Sub viewModel_CloseRequested(ByVal sender As Object, ByVal e As EventArgs)
			OnExitRequested(EventArgs.Empty)
		End Sub

		Protected Overridable Sub OnExitRequested(ByVal e As EventArgs)
			RaiseEvent ExitRequested(Me, e)
		End Sub
	End Class
End Namespace
